REST API: Filter issues created/updated before or after specific timestamp
Status: Closed Start date: 2011-07-18
Priority: Normal Due date:

Assignee: Jean-Philippe Lang % Done: 0%
Category: REST API Estimated time: 0.00 hour
Target version: 25.0

Resolution: Fixed

Description

The current REST API allows for simple extraction of issue details and such things. For developing a more advanced client, keeping
track of a very large Redmine issue list, it's not really enough. Yes, you can simply fetch the entire issue list, but that's barbaric and
evil. So why not implement a new filter, allowing the database do all of the hard work for us?

GET /issues.xml?from=20110507T174311
I'm quite proud of this myself. Doesn't put unneeded stress on the server if an app is fetching the entire issue list every few seconds,

and allows smart external tools to skip XML parsing of a huge amount of non-updated issues. The same filter could also be added to
projects, versions, relations and so on. Or maybe a combined feed where you would get them all.

Related issues:
Related to Redmine - Defect #15780: Filter issues by date time (instead of on... Closed

Associated revisions

Revision 12477 - 2014-01-03 16:54 - Jean-Philippe Lang
Allow filtering with timestamp (#8842).

Revision 12478 - 2014-01-03 17:36 - Jean-Philippe Lang
Fixed test failure with sqlite (#8842).

Revision 12479 - 2014-01-03 20:42 - Jean-Philippe Lang
Fixed test failure with ruby1.8 (#8842).

Revision 12480 - 2014-01-04 09:22 - Jean-Philippe Lang
Fixed assertion for postgresql and sqlite (#8842).

History

#1 - 2011-11-30 14:58 - Markus Korber

+1
#2 - 2012-03-07 14:47 - Etienne Massip
You can already use

GET /issues.xml?updated_on=>=2012-03-07

#3 - 2012-03-07 15:45 - Jens Backman

Hmm... That's not mentioned in the Rest API wiki page for Issues.
http://www.redmine.org/projects/redmine/wiki/Rest_lssues

#4 - 2012-03-07 19:35 - Alex Last
what about "issues created after", not just "updated on"?
actually, then best approach would be to retrieve "redmine server activity" with all (or some filtered) events within certain time period.

e.g. "show me what happened since Jan 1st" or "show me what happened with issues since Jan 1st. this info is crucial for Redmine-Redmine sync,
which was requested by several people.
http://www.redmine.org/projects/redmine/wiki/Rest_Issues

| submitted #10402 about this.

#5 - 2012-05-03 18:22 - Jeffrey Clark

Not sure when this was added, but you can do:

/issues.xml?created_on=><2012-03-01|2012-03-07

#6 - 2013-11-06 21:21 - Oleksandr Melnyk

You can already use
GET /issues.xml?updated_on=>=2012-03-07

Yes, but it doesn't accept time eg. updated_on=>=2013-11-06T19:59:05Z. And it crucial when developing, for example, synchronization functionality.

#7 - 2013-12-30 05:53 - Toshi MARUYAMA
- Related to Defect #15780: Filter issues by date time (instead of only date) in REST API added

#8 - 2014-01-03 16:59 - Jean-Philippe Lang

- Subject changed from REST API: Filter issues updated after specific timestamp to REST API: Filter issues created/updated before or after specific
timestamp

- Status changed from New to Closed
- Assignee set to Jean-Philippe Lang
- Target version set to 2.5.0

- Resolution set to Fixed

Feature added in r12477. Using a from parameter, you'll have to use the regular syntax with a timestamp instead of a date (see examples in
Rest_lIssues).
